library PicButtonByDll;

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  PicButton;

{  *** solution 1 (be ragit pas au clic gauche) }
Type
    TDummy = class
      class procedure PicButtonDynamiqueDLLClick1(Sender: TObject);
  end;

{  *** solution 2 (ne ragit pas au clic gauche) }
Type TMethodPointer = packed record
    pMethod: Pointer;
    pObject: TObject;
end;

var
  frmDllForm: TForm;

{$R *.res}

{  *** pour solution 1 }
class procedure TDummy.PicButtonDynamiqueDLLClick1(Sender: TObject);
begin
  ShowMessage('Clic sur PicButton "par DLL" solution 1');
end;

{  ** pour solution 2  }
procedure PicButtonDynamiqueDLLClick2(Sender: TObject);
begin
  ShowMessage('Clic sur PicButton "par DLL" solution 2');
end;           

function CreatePicButtonByDLL(hnd: HWND; xtop, xleft, solution: integer):TPicButton; StdCall; Export;
var
  bm: TBitMap;
{  *** pour solution 2  }
  Method: TMethodPointer;
begin
  result := nil;
  try
    result := TPicButton.Create(frmDllForm);
    result.ParentWindow := hnd;
    result.Top := xtop;
    result.Left := xleft;

{  *** pour solution 2   }
    Method.pMethod := @PicButtonDynamiqueDLLClick2;
    Method.pObject := nil;


    bm := TBitMap.Create;
    bm.LoadFromFile('Boutons2.bmp');
    result.PicNormal := bm;
    bm.LoadFromFile('Boutons2Down.bmp');
    result.PicPushed := bm;
    bm.LoadFromFile('Boutons2Hover.bmp');
    result.PicHiLight := bm;
    bm.Free;
    result.SetFocus;
    
{  *** pour solution 1 }
    if solution=1 then result.OnClick := TDummy.PicButtonDynamiqueDLLClick1;
{  *** pour solution 2   ne ragit pas au clic gauche   }
    if solution=2 then result.OnClick := TNotifyEvent(Method);
  except
    ShowMessage('Oups... Erreur en cration.');
  end;
end;

procedure DeletePicButtonByDLL(pb: TPicButton); StdCall; Export;
begin
  if assigned(pb) then pb.Free;
end;

procedure ClickPicButtonByDLL(pb: TPicButton); StdCall; Export;
begin
  if assigned(pb) then pb.Click;
end;


Exports
  CreatePicButtonByDLL, DeletePicButtonByDLL, ClickPicButtonByDLL;

begin
end.

