unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PicButton;

type
  TCreatePicButtonByDLL = function (hnd: HWND; xtop, xleft, position: integer):TPicButton; stdcall;
  TDeletePicButtonByDLL = procedure (pb: TPicButton); stdcall;
  TClickPicButtonByDLL = procedure (pb: TPicButton); stdcall;

  TForm1 = class(TForm)
    PicButton1: TPicButton;
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure PicButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PicButtonDynamiqueClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

{
function CreatePicButtonByDLL(hnd: HWND; xtop, xleft, position: integer):TPicButton; stdcall; external 'PicButtonByDLL.dll';
procedure DeletePicButtonByDLL(pb: TPicButton); stdcall; external 'PicButtonByDLL.dll';
procedure ClickPicButtonByDLL(pb: TPicButton); stdcall; external 'PicButtonByDLL.dll';
}

var
  Form1: TForm1;
  PicButtonDynamique: TPicButton;
  PicButtonDynamiqueDLL: TPicButton;
  DLL: cardinal;
  CreatePicButtonByDLL: TCreatePicButtonByDLL;
  DeletePicButtonByDLL: TDeletePicButtonByDLL;
  ClickPicButtonByDLL:  TClickPicButtonByDLL;

Implementation

{$R *.dfm}

procedure TForm1.PicButton1Click(Sender: TObject);
begin
  ShowMessage('Clic sur PicButton "design time"');
end;

procedure TForm1.PicButtonDynamiqueClick(Sender: TObject);
begin
  ShowMessage('Clic sur PicButton "run time"');
end;


procedure TForm1.Button1Click(Sender: TObject);
var
  bm: TBitMap;
begin
  if assigned(PicButtonDynamique) then begin
    ShowMessage('Le bouton est dj cr !');
    exit;
  end;
  try
    PicButtonDynamique := TPicButton.Create(self);
//    PicButtonDynamique.ParentWindow := Form1.Handle;
    PicButtonDynamique.Parent := Form1;
    PicButtonDynamique.Top := Button1.Top+100;
    PicButtonDynamique.Left := PicButton1.Left;
    PicButtonDynamique.OnClick := PicButtonDynamiqueClick;

    bm := TBitMap.Create;
    bm.LoadFromFile('Boutons2.bmp');
    PicButtonDynamique.PicNormal := bm;
    bm.LoadFromFile('Boutons2Down.bmp');
    PicButtonDynamique.PicPushed := bm;
    bm.LoadFromFile('Boutons2Hover.bmp');
    PicButtonDynamique.PicHiLight := bm;
    bm.Free;
    PicButtonDynamique.SetFocus;          // <========== pour afficher l'image !
  except
    ShowMessage('Oups... Erreur en cration.');
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if assigned(PicButtonDynamiqueDLL) then begin
    ShowMessage('Le bouton est dj cr !');
    exit;
  end;
  PicButtonDynamiqueDLL :=
      CreatePicButtonByDLL(GetForegroundWindow(),      // placer dans la fentre principale
      Form1.Button2.Top+100, Form1.Button2.Left,       // position dans la fentre
      ComboBox1.ItemIndex);                            // choisir le mode de dfintion de Onclick
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex := 0;
  Label1.Caption := 'Pas de raction sur Onclick - normal.'+#13#10+
                    'Les bitmaps ne sont pas affiches';
  Label2.Caption := 'Onclick marche.'+#13#10+'Les bitmaps sont affiches.';
  DLL := LoadLibrary('PicButtonByDLL.dll') ;
  @CreatePicButtonByDLL := GetProcAddress(DLL, 'CreatePicButtonByDLL');
  @DeletePicButtonByDLL := GetProcAddress(DLL, 'DeletePicButtonByDLL');
  @ClickPicButtonByDLL := GetProcAddress(DLL, 'ClickPicButtonByDLL');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  PicButtonDynamique.Free;
  PicButtonDynamique := nil;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if assigned(PicButtonDynamique) then PicButtonDynamique.Click;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  DeletePicButtonByDLL(PicButtonDynamiqueDLL);
  PicButtonDynamiqueDLL := nil;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  ClickPicButtonByDLL(PicButtonDynamiqueDLL);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if assigned(PicButtonDynamiqueDLL) then begin
    PicButtonDynamiqueDLL.Free;
    PicButtonDynamiqueDLL := nil;
    Button2Click(Button2);
  end;
  case ComboBox1.ItemIndex of
    0: Label1.Caption := 'Pas de raction sur Onclick - normal.'+#13#10+
                         'Les bitmaps ne sont pas affiches';
    1: Label1.Caption := 'Clic sur bouton "Tester Onclick" marche,'+#13#10+
                          'Clic sur le PicButton ne marche pas !'+#13#10+
                         'Les bitmaps ne sont pas affiches';
    2: Label1.Caption := 'Clic sur bouton "Tester Onclick" marche,'+#13#10+
                          'Clic sur le PicButton ne marche pas !'+#13#10+
                         'Les bitmaps ne sont pas affiches';
  end;
end;

end.
